
unit Log;

interface

uses
  SysUtils;
  
type
  TLog = class
  private
    FName: TFileName;
  public
    constructor Create(const AUnitName: string);
    procedure Add(const ALine: string; const ARewrite: boolean = FALSE);
  end;
  
implementation

constructor TLog.Create(const AUnitName: string);
begin
  FName := ChangeFileExt(AUnitName, '.log');
end;

procedure TLog.Add(const ALine: string; const ARewrite: boolean);
var
  LLog: TextFile;
  LTime: string;
begin
  Assign(LLog, FName);
  if ARewrite or not FileExists(FName) then
    Rewrite(LLog)
  else
    Append(LLog);
  LTime := DateTimeToStr(Now);
  WriteLn(LLog, LTime, ' ', ALine);
  Close(LLog);
end;

end.
